@startuml

class Messenger {
    +{static} static dependencies
    +{static} static ACTION_RENDER_CHAT_ACTIVE
    +{static} static ACTION_REQUEST_CHAT
    +{static} static ACTION_WELCOME_MESSAGE
    +{static} static ACTION_REMOVE_WELCOME_CHAT
}

class DefaultMessenger {
    +{static} static implements
    +{static} static overwriteServerDescriptor
    +{static} static dependencies
    +{static} static start()
    +{static} static testReference
    +constructor()
    +init()
    +publicShifter()
    +userIcon()
    +validMessenger()
    +welcomeMessage(messengerIORString)
    +removeWelcomeChat(messengerIORString)
    +requestChat(chatIOR)
    +isValidNewChat(chat)
    +isOwnMessenger
    +loadIORs(data)
    +chatReferences
    +chatReferences(value)
    +shifterID
    +activeChat
    +activeChat(chat)
    +unreadMessages()
    +setActiveChat(incomeActiveChat)
    +onDomReadyView(view)
    +createDefaultView()
    +add(component)
    +showChatview()
    +showOverview()
    +showInfoview()
    +onUnreadMessagesChanged()
    +addMessenger(otherMessenger)
    +onModelChanged(changeEvent, updateObject)
    +checkMaxOffline()
    +isAlreadyConnected(otherMessenger)
    +addChat(chat)
    +removeChat()
    +initChatInfo()
}

class MessengerDefaultView {
    +{static} static declareUnits
    +onUpdate(updateObject)
    +buildDom(chat, messenger)
    +buildViews(chat, messenger)
    +afterRender()
    +onDomReady()
}

class MessengerCompactView {
    +{static} static implements
    +{static} static declareUnits
    +onUpdate()
    +afterRender(view)
}

class MessengerDetailView {
    +{static} static declareUnits
    +onUpdate()
    +onDomReady(view)
}

class MessengerUnreadMessages {
    +{static} static implements
    +{static} static declareUnits
    +setUnreadMessages()
    +afterRender()
    +onUpdate()
}

Messenger <|-- DefaultMessenger
DefaultMessenger <|-- MessengerDefaultView
DefaultMessenger <|-- MessengerCompactView
DefaultMessenger <|-- MessengerDetailView
DefaultMessenger <|-- MessengerUnreadMessages

@enduml